jif

## Class JifOptions

- java.lang.Object
- - polyglot.main.Options
  - - jif.JifOptions

-     public class JifOptions
      extends polyglot.main.Options

  This object encapsulates various polyglot options.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `JifOptions.JifLocations`

    - ### Nested classes/interfaces inherited from class polyglot.main.Options

      `polyglot.main.Options.StdPathFlag`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected boolean` | `authFromProvider` Whether to use the provider label for authorization checks when downgrading policies.
    `boolean` | `dependencyGraph` Output a dependency graph to help the diagnosing of type error?
    `boolean` | `explainErrors` Provide more detailed explanation of solver error messages?
    `boolean` | `fatalExceptions` Should uncaught exceptions be made fatal?
    `boolean` | `nonRobustness` Should the checking for the robustness condition be disabled?
    `protected boolean` | `noWarnings` Suppress compile-time warnings, such as those for fail-on-exception.
    `java.util.List<java.io.File>` | `sigcp` The classpath for the Jif signatures of java.lang objects.
    `boolean` | `skipLabelChecking` Should we skip label checks entirely?
    `boolean` | `solveGlobally` Use a single Solver to infer labels globally, or solve on a class by class basis.
    `boolean` | `trustedProviders` Whether the providers of the sources being compiled are trusted.

    - ### Fields inherited from class polyglot.main.Options

      `arguments, assertions, bootclasspath, bootclasspath_given, class_output, classpath, classpath_given, compile_command_line_only, disable_passes, dump_ast, error_count, extension, flags, fully_qualified_names, generate_debugging_info, global, ignore_mod_times, keep_output_files, merge_strings, noOutputToFS, output_ext, output_source_only, output_stdout, output_width, post_compiler, post_compiler_opts, precise_compiler_generated_positions, print_args, print_ast, serialize_type_info, source_ext, source_output, source_path, sourcepath_directories, USAGE_FLAG_WIDTH, USAGE_SCREEN_WIDTH, USAGE_SUBSECTION_INDENT, use_simple_code_writer`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JifOptions(ExtensionInfo extension)` Constructor

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `authFromProvider()`
    `protected void` | `handleArg(polyglot.main.OptFlag.Arg<?> arg)`
    `boolean` | `noWarnings()`
    `protected void` | `populateFlags(java.util.Set<polyglot.main.OptFlag<?>> flags)`

    - ### Methods inherited from class polyglot.main.Options

      `addBootCP, addDisablePass, addDumpAST, addPrintAST, addReportTopic, addSourceExtension, applyArgs, arguments, bootclasspathDirectories, classOutputDirectory, classOutputLocation, classpathDirectories, constructPostCompilerClasspath, defaultPlatformClasspath, filterArgs, flags, handleSourceArg, jvmbootclasspath, outputLocation, parseCommand, parseCommandLine, parseSourceArg, postApplyArgs, printCommandLine, printSpaces, processArguments, sccast, setAssertions, setBootclasspath, setClassOutput, setClasspath, setCommandLineOnly, setDebugPositions, setDefaultValues, setErrorCount, setFullyQualifiedNames, setGenerateDebugInfo, setIgnoreModTimes, setMergeStrings, setNoOutput, setNoSerializedTypes, setOutputExtension, setOutputOnly, setOutputStdOut, setOutputWidth, setPostCompiler, setPostCompilerOpts, setSimpleOutput, setSourceOutput, setSourcepath, setVerbose, sourceOutputDirectory, usage, usage, usageForFlag, usageHeader, usageSubsection, validateArgs`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### nonRobustness

          public boolean nonRobustness

      Should the checking for the robustness condition be disabled?

    - #### fatalExceptions

          public boolean fatalExceptions

      Should uncaught exceptions be made fatal?

    - #### skipLabelChecking

          public boolean skipLabelChecking

      Should we skip label checks entirely?

    - #### solveGlobally

          public boolean solveGlobally

      Use a single Solver to infer labels globally, or solve on a class by class basis.

    - #### explainErrors

          public boolean explainErrors

      Provide more detailed explanation of solver error messages?

    - #### trustedProviders

          public boolean trustedProviders

      Whether the providers of the sources being compiled are trusted.

    - #### sigcp

          public final java.util.List<java.io.File> sigcp

      The classpath for the Jif signatures of java.lang objects.

    - #### dependencyGraph

          public boolean dependencyGraph

      Output a dependency graph to help the diagnosing of type error?

    - #### noWarnings

          protected boolean noWarnings

      Suppress compile-time warnings, such as those for fail-on-exception.

    - #### authFromProvider

          protected boolean authFromProvider

      Whether to use the provider label for authorization checks when downgrading policies.

  - ### Constructor Detail

    - #### JifOptions

          public JifOptions(ExtensionInfo extension)

      Constructor

  - ### Method Detail

    - #### populateFlags

          protected void populateFlags(java.util.Set<polyglot.main.OptFlag<?>> flags)

      Overrides:
        `populateFlags` in class `polyglot.main.Options`

    - #### handleArg

          protected void handleArg(polyglot.main.OptFlag.Arg<?> arg)
                            throws polyglot.main.UsageError

      Overrides:
        `handleArg` in class `polyglot.main.Options`
      Throws:
        `polyglot.main.UsageError`

    - #### noWarnings

          public boolean noWarnings()

    - #### authFromProvider

          public boolean authFromProvider()